"use strict";
/**
 * Copyright ou © ou Copr. Ministère de l'Europe et des Affaires étrangères (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * Ce logiciel est un programme informatique servant à faciliter la création
 * d'applications Web conformément aux référentiels généraux français : RGI, RGS et RGAA
 * <p/>
 * Ce logiciel est régi par la licence CeCILL soumise au droit français et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA
 * sur le site "http://www.cecill.info".
 * <p/>
 * En contrepartie de l'accessibilité au code source et des droits de copie,
 * de modification et de redistribution accordés par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
 * seule une responsabilité restreinte pèse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concédants successifs.
 * <p/>
 * A cet égard  l'attention de l'utilisateur est attirée sur les risques
 * associés au chargement,  à l'utilisation,  à la modification et/ou au
 * développement et à la reproduction du logiciel par l'utilisateur étant
 * donné sa spécificité de logiciel libre, qui peut le rendre complexe à
 * manipuler et qui le réserve donc à des développeurs et des professionnels
 * avertis possédant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
 * logiciel à leurs besoins dans des conditions permettant d'assurer la
 * sécurité de leurs systèmes et ou de leurs données et, plus généralement,
 * à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.
 * <p/>
 * Le fait que vous puissiez accéder à cet en-tête signifie que vous avez
 * pris connaissance de la licence CeCILL, et que vous en avez accepté les
 * termes.
 * <p/>
 * <p/>
 * Copyright or © or Copr. Ministry for Europe and Foreign Affairs (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * This software is a computer program whose purpose is to facilitate creation of
 * web application in accordance with french general repositories : RGI, RGS and RGAA.
 * <p/>
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 * <p/>
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 * <p/>
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 * <p/>
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 *
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/**
 * hornet-js-core - Ensemble des composants qui forment le coeur de hornet-js
 *
 * @author MEAE - Ministère de l'Europe et des Affaires étrangères
 * @version v5.4.1
 * @link git+https://github.com/diplomatiegouvfr/hornet-js.git
 * @license CECILL-2.1
 */
var hornet_js_utils_1 = require("hornet-js-utils");
var technical_error_1 = require("hornet-js-utils/src/exception/technical-error");
var logger_1 = require("hornet-js-logger/src/logger");
var logger = logger_1.Logger.getLogger("hornet-js-core.services.superagent-hornet-plugins");
var browser = require("detect-browser");
var HEADER_CSRF_NAME = "x-csrf-token";
var HEADER_LOGIN_PAGE = "x-is-login-page";
var HornetPlugin = /** @class */ (function () {
    function HornetPlugin() {
    }
    HornetPlugin.getPlugin = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        throw new technical_error_1.TechnicalError("NOT IMPLEMENTED");
    };
    return HornetPlugin;
}());
exports.HornetPlugin = HornetPlugin;
/**HornetPlugin
 * Plugin SuperAgent ajoutant le header csrf lors de l'envoi des requêtes et gérant la récupération du nouveau token lors du retour
 * @param request
 * @return {HornetSuperAgentRequest}
 * @constructor
 */
var CsrfPlugin = /** @class */ (function (_super) {
    tslib_1.__extends(CsrfPlugin, _super);
    function CsrfPlugin() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CsrfPlugin.getPlugin = function () {
        return function (request) {
            logger.trace("Ajout du token csrf.");
            if (!hornet_js_utils_1.Utils.isServer) {
                logger.trace("Ajout du token csrf valeur : ", hornet_js_utils_1.Utils.getCls("hornet.csrf") || "no-token");
                // Ajout du token à l'envoi
                request.set(HEADER_CSRF_NAME, hornet_js_utils_1.Utils.getCls("hornet.csrf") || "no-token");
            }
        };
    };
    return CsrfPlugin;
}(HornetPlugin));
exports.CsrfPlugin = CsrfPlugin;
/*export function CsrfPlugin(request:HornetSuperAgentRequest) {
    if (!Utils.isServer) {
        // Ajout du token à l'envoi
        request.set(HEADER_CSRF_NAME, Utils.getCls("hornet.csrf") || "no-token");
    }
}*/
/**
 * Plugin SuperAgent permettant de contourner les problèmes liés au cache sous IE
 * @param request
 * @return {HornetSuperAgentRequest}
 * @constructor
 */
var noCacheIEPlugin = /** @class */ (function (_super) {
    tslib_1.__extends(noCacheIEPlugin, _super);
    function noCacheIEPlugin() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    noCacheIEPlugin.getPlugin = function () {
        return function (request) {
            if (!hornet_js_utils_1.Utils.isServer && browser.name === "ie") {
                request.set("If-Modified-Since", "Sun, 12 Jul 1998 05:00:00 GMT");
                request.set("Cache-Control", "no-cache, no-store, must-revalidate");
                request.set("Pragma", "no-cache");
                request.set("Expires", "0");
            }
        };
    };
    return noCacheIEPlugin;
}(HornetPlugin));
exports.noCacheIEPlugin = noCacheIEPlugin;
/**
 * Plugin SuperAgent détectant une redirection vers la page de login et redirigant le navigateur vers cette page.
 * Pour détecter cette redirection il recherche dans les headers de la réponse le header 'x-is-login-page' valant "true"
 * @param request
 * @return {HornetSuperAgentRequest}
 * @constructor
 */
var RedirectToLoginPagePlugin = /** @class */ (function (_super) {
    tslib_1.__extends(RedirectToLoginPagePlugin, _super);
    function RedirectToLoginPagePlugin() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RedirectToLoginPagePlugin.getPlugin = function () {
        return function (request) {
            if (!hornet_js_utils_1.Utils.isServer) {
                // Gestion du header
                var realRequest = request.callback;
                request.callback = function (err, res) {
                    if (res && res.get(HEADER_LOGIN_PAGE) == "true") {
                        var loginUrl = hornet_js_utils_1.Utils.buildContextPath(hornet_js_utils_1.Utils.appSharedProps.get("loginUrl"));
                        logger.debug("Redirection vers la page:", loginUrl);
                        window.location.href = loginUrl + "?previousUrl=" + window.location.href;
                    }
                    else {
                        realRequest.call(this, err, res);
                    }
                };
            }
        };
    };
    return RedirectToLoginPagePlugin;
}(HornetPlugin));
exports.RedirectToLoginPagePlugin = RedirectToLoginPagePlugin;
/**
 * Plugin SuperAgent ajoutant les données telques le tid et le user à la requête du serveur
 * @param nom du localstorage
 * @return {HornetSuperAgentRequest}
 * @constructor
 */
var AddParamFromLocalStorage = /** @class */ (function (_super) {
    tslib_1.__extends(AddParamFromLocalStorage, _super);
    function AddParamFromLocalStorage() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AddParamFromLocalStorage.getPlugin = function (param, propNameName, localStorageName) {
        return function (request) {
            logger.trace("Ajout Param request from local storage.");
            if (hornet_js_utils_1.Utils.isServer) {
                var callbacksStorage = hornet_js_utils_1.Utils.getContinuationStorage(localStorageName);
                // var callbacksStorage = require("hornet-js-utils/src/callbacks-local-storage").getStorage(localStorageName);
                var paramValue = callbacksStorage.get(propNameName || param);
                var queryParameters = {};
                queryParameters[param] = paramValue;
                logger.trace("Ajout des paramètres superAgent,", param, ":", paramValue);
                request.query(queryParameters);
            }
        };
    };
    ;
    return AddParamFromLocalStorage;
}(HornetPlugin));
exports.AddParamFromLocalStorage = AddParamFromLocalStorage;
/**
 * Plugin SuperAgent ajoutant les données telques le tid et le user à la requête du serveur
 * @param nom du localstorage
 * @return {HornetSuperAgentRequest}
 * @constructor
 */
var AddParam = /** @class */ (function (_super) {
    tslib_1.__extends(AddParam, _super);
    function AddParam() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AddParam.getPlugin = function (param, paramValue) {
        return function (request) {
            logger.trace("Ajout Param request.");
            if (hornet_js_utils_1.Utils.isServer) {
                var queryParameters = {};
                queryParameters[param] = paramValue;
                logger.trace("Ajout des paramètres superAgent,", param, ":", paramValue);
                request.query(queryParameters);
            }
        };
    };
    return AddParam;
}(HornetPlugin));
exports.AddParam = AddParam;

//# sourceMappingURL=superagent-hornet-plugins.js.map
